-- STEAMROLLER is a slightly modified version of PREFORM AV ENABLER (version 1.21)
-- CODING CREDITS go to TORRID!

-- However, s/he is NOT the one to blame for the renewed steamrolling in AB, EOTS and WSG made possible by this addon.
-- In my opinion, BLIZZARD should have kept a way open for friends to play battlegrounds together, queue times in 2.4 for preformed groups are beyond reasonable.
-- April 1, 2008 (Anonymous)

-- (c) Torrid of www.torridreflections.com, aka Torrid/Torec/Torvie of Black Dragonflight USA
-- if this file is posted to a web site, credit must be given to me along with a link to my web page
-- "this file may be distributed so long as it remains unaltered" - "no code in this file may be used in other works without expressed permission". 
-- Sorry Torrid - I did not see a reason to reinvent the wheel - I did however change as little as possible to make it queue for other battlegrounds as well - I hope you will forgive me one day (Anonymous)

local Steamroller_Version = 1.221;
local Steamroller_Status = {};
local Steamroller_MyStatus = { frame = 0, queued = 0, av = 0, deserter = 0, };
local Steamroller_Members = {};		-- = { name = "", online = 0 or 1 }
local Steamroller_Pending = 0;		-- if non-zero, attempt to join this av
local Steamroller_OnUpdateTime = 0;	-- used to prevent redundant status redraws
local Steamroller_Debug = false;
local Steamroller_NewGroup = true;		-- send status update when joing new group
local Steamroller_LastStatus = "";		-- used to prevent 
local Steamroller_LastStatusTime = 0;	-- redundant status sending
local Steamroller_WaitUntilReady = false;	-- to prevent leave queue spam
--local Steamroller_QTime = 0;			-- timestamp of when queued
--local Steamroller_ClosedTime = 0;		-- timestamp of when battlefield frame was closed
--local Steamroller_PlayerQueuedHimself = true;	-- did the instance window close within 3 seconds of being queued?
local Steamroller_HideTime = 0;		-- timestamp of when the hide signal was seen
local Steamroller_LastNotify = 0;		-- time() of last notify signal seen, + 10 seconds
Steamroller_Automating = false;
Steamroller_Threshold = 30;
Steamroller_NeverUpdated = 0;		-- used to determine if a status update was ever seen between the time player got member data and
							-- player opened status window (don't request status update if player has everybody's status)
Steamroller_LastCheck = 0;			-- used to prevent redundant status updates

Steamroller_SelectedBG = 1;			-- AV

function SteamrollerFrame_OnLoad(frame)
	SlashCmdList["STEAMROLL"] = SteamrollerCmdLine;
	SLASH_STEAMROLL1 = STEAMROLLER_CMD;

	frame:RegisterEvent("CHAT_MSG_ADDON");
	frame:RegisterEvent("PARTY_MEMBERS_CHANGED");
	frame:RegisterEvent("RAID_ROSTER_UPDATE");
	frame:RegisterEvent("UPDATE_BATTLEFIELD_STATUS");
	frame:RegisterEvent("PARTY_LEADER_CHANGED");
	frame:RegisterEvent("BATTLEFIELDS_SHOW");
	frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	frame:RegisterEvent("PARTY_INVITE_REQUEST");

	Steamroller_SetWidgets();
	BattlefieldFrame:HookScript("OnShow", Steamroller_BattlefieldFrameOnShowHook);
	BattlefieldFrame:HookScript("OnHide", Steamroller_BattlefieldFrameOnHideHook);

	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage("|c00ffff00"..STEAMROLLER_SELF.."|r v|c0000ffff"..Steamroller_Version.."|r loaded.  |c0000ff00"..STEAMROLLER_CMD.."|r to use");
	end
end

function Steamroller_SetWidgets()
	if ( IsRaidLeader() or IsPartyLeader() ) then
		SteamrollerFrameQueueButton:Show();
		SteamrollerFrameJoinButton:Show();
		SteamrollerAutomateCheckButton:Show();
		SteamrollerAutomateCheckButtonText:Show()
		SteamrollerThresholdSlider:Show();
		SteamrollerFrameLeaveButton:SetText(STEAMROLLER_GROUPLEAVE);
		Steamroller_LeaveButtonTooltip = Steamroller_LocalString(STEAMROLLER_TOOLTIP4);
		SteamrollerFrameLeaveAllButton:Show();
		SteamrollerFrameNotifyButton:Show();
		if ( BattlefieldFrame:IsVisible() ) then
			SteamrollerFrameNotifyButton:Enable();
		else
			SteamrollerFrameNotifyButton:Disable();
		end
	else
		SteamrollerFrameJoinButton:Hide();
		SteamrollerFrameQueueButton:Hide();
		SteamrollerAutomateCheckButton:Hide();
		SteamrollerAutomateCheckButtonText:Hide()
		SteamrollerThresholdSlider:Hide();
		SteamrollerFrameLeaveButton:SetText(LEAVE_QUEUE);
		SteamrollerFrameLeaveAllButton:Hide();
		SteamrollerFrameNotifyButton:Hide();
	end
	Steamroller_DropDown_Update()
end

function Steamroller_LocalString(str)
	str = string.gsub(str, "@M", STEAMROLLER_MAP[Steamroller_SelectedBG])
	str = string.gsub(str, "@S", STEAMROLLER_MAP_SHORT[Steamroller_SelectedBG])	
	return str
end

function Steamroller_SendStatus()
	Steamroller_MyStatus.deserter = Steamroller_CheckDeserter();

	local msg = "mystatus,"..Steamroller_Version..","
		..Steamroller_MyStatus.frame..","			-- if the correct window is open or not
		..Steamroller_MyStatus.queued..","			-- if he is currently in queue for the selected battleground
		..Steamroller_MyStatus.av..","			-- if he is already in the selected battleground
		..Steamroller_MyStatus.deserter;			-- if he has the deserter debuff

	-- if you are the leader, also add which battleground you currently have selected
	if ( IsRaidLeader() or IsPartyLeader() ) then
		msg = msg .. "," .. Steamroller_SelectedBG;
	end

	-- if this status message is the same as the last one sent, and not two seconds have passed, then don't send
	if ( Steamroller_LastStatus == msg and Steamroller_LastStatusTime > GetTime() ) then
		return
	end

	Steamroller_LastStatusTime = GetTime() + 2;	-- do not send redundant messages within two seconds
	Steamroller_LastStatus = msg;

	if ( Steamroller_Debug ) then
		DEFAULT_CHAT_FRAME:AddMessage(" >>> Sending my status: "..msg, 0, 1, 1);
	end

	SendAddonMessage("Steamroller", msg, "RAID");
end

function Steamroller_BattlefieldFrameOnShowHook()
	local mapName = GetBattlefieldInfo();

	if ( mapName == STEAMROLLER_MAP[Steamroller_SelectedBG] ) then
		Steamroller_MyStatus.frame = 1;

		if ( IsRaidLeader() or IsPartyLeader() ) then
			SteamrollerFrameNotifyButton:Enable();
		end

		if ( Steamroller_Debug ) then
			DEFAULT_CHAT_FRAME:AddMessage(mapName.." battlemaster window opened", 0, 1, 1);
		end

		Steamroller_SendStatus();
	end
end

function Steamroller_BattlefieldFrameOnHideHook()

	if ( Steamroller_MyStatus.frame == 1 ) then
		Steamroller_MyStatus.frame = 0;

		if ( IsRaidLeader() or IsPartyLeader() ) then
			SteamrollerFrameNotifyButton:Disable();
		end

		if ( Steamroller_Debug ) then
			DEFAULT_CHAT_FRAME:AddMessage("AV battlemaster window closed", 0, 1, 1);
		end

		Steamroller_SendStatus();
	end
end

-- redraw every 10 seconds in case of deserter or anything that may need drawing
function SteamrollerFrame_OnUpdate(arg)
	Steamroller_OnUpdateTime = Steamroller_OnUpdateTime + arg;
	if ( Steamroller_OnUpdateTime > 10 ) then
		Steamroller_OnUpdateTime = 0;
		Steamroller_Update();
	end
end

function Steamroller_LeaveQueue()
	local avStatus, avId, avQid, currentBg, currentBgId = Steamroller_AvStatus();

	if ( avStatus == "confirm" or avStatus == "queued" ) then
		if ( Steamroller_Debug ) then
			DEFAULT_CHAT_FRAME:AddMessage("Leaving AV queue", 0, 1, 1);
		end

		AcceptBattlefieldPort(avQid, 0);

		if ( currentBg > 0 ) then
			Steamroller_MyStatus.queued = currentBg;
		end
		if ( currentBgId > 0 ) then
			Steamroller_MyStatus.av = currentBgId;
		else
			Steamroller_MyStatus.av = 0;
		end
		Steamroller_HideTime = 0;
	end

	Steamroller_CheckBattlefieldFrame();
end

function Steamroller_Queue(queueId, dontSpeak)
	queueId = tonumber(queueId);

	if ( (Steamroller_MyStatus.frame == 1) ) then
		if ( not queueId ) then
			-- first avail
			JoinBattlefield(0);
			Steamroller_HideTime = GetTime();
		else
			-- specific av
			local i, instanceId;
			for i = 1, GetNumBattlefields() do
				instanceId = GetBattlefieldInstanceInfo(i);
				if ( instanceId == queueId ) then
					JoinBattlefield(i);
					break;
				end
			end

			Steamroller_SetPending(queueId);

			-- specified AV not listed, player needs to re-open the window
			if ( not dontSpeak ) then
				DEFAULT_CHAT_FRAME:AddMessage(STEAMROLLER_INSTANCE..queueId..STEAMROLLER_NOTFOUND, 1, 0, 0);
			end

		end
	end
end

function Steamroller_MassQueue()
	if ( Steamroller_MyStatus.queued == 0 ) then

		if ( Steamroller_Debug ) then
			DEFAULT_CHAT_FRAME:AddMessage("Sending queue signal to everybody \"Open\"", 0, 1, 1);
		end
		SendAddonMessage("Steamroller", "hide", "RAID");
		SendAddonMessage("Steamroller", "queue", "RAID");
		return
	end
end

function Steamroller_SetPending(n)
	if ( n and n > 0 ) then
		Steamroller_Pending = n;
		SteamrollerPendingText:SetText(Steamroller_LocalString(STEAMROLLER_ATTEMPT)..n);
		Steamroller_HideTime = 0;
	else
		SteamrollerPendingText:SetText("");
		Steamroller_Pending = 0;
	end
end

function Steamroller_MapIsBattleground(map)
	for i, val in pairs(STEAMROLLER_MAP) do
		if map == val then
			return i 
		end
	end
	return nil
end

function Steamroller_Tally()
	-- returns:
	-- determine the majority AV,
	-- how many got it,
	-- how many got an AV at all,
	-- unqueued people,
	-- queued people,
	-- total raid members that are able to queue,
	-- is everybody ready?
	
	local i, val;
	local allReady = true;
	local people = 0;
	local unqueuedPeople = 0;
	local queuedPeople = 0;
	local hisStatus;
	local AV = {};

	for i, val in pairs(Steamroller_Members) do

		hisStatus = Steamroller_Status[val.name];

		-- if player is online, we have his status info, and is not inside a BG, and not deserter (only these people will count)
		if (	val.online and
			hisStatus and
			hisStatus.queued < 3 and
			hisStatus.deserter < ( GetTime() + 1 )		-- add one extra second for good measure
		) then
			people = people + 1;

			-- is everybody ready?
			if ( Steamroller_MyStatus.frame ~= 1 or hisStatus.frame ~= 1 or hisStatus.queued ~= 0 or hisStatus.av > 0 ) then
				allReady = false;
			end

			-- these people might possibly get the AV we want
			-- include non-queued else they might trigger a requeue when not wanted
			if ( hisStatus.queued == 1 ) then
				queuedPeople = queuedPeople + 1;
			elseif ( hisStatus.queued == 0 ) then
				unqueuedPeople = unqueuedPeople + 1;
			end

			-- tally up confirm AVs
			if ( hisStatus.av > 0 and hisStatus.queued == 2) then
				-- this guy has an AV
				if ( AV[hisStatus.av] ) then
					AV[hisStatus.av] = AV[hisStatus.av] + 1;
				else
					AV[hisStatus.av] = 1;
				end

			end

		end
	end

	local av, num;
	local highestAV = 0;
	local haveConfirm = 0;

	for av, num in pairs(AV) do
		if ( not AV[highestAV] ) then
			highestAV = av;			-- first av in table
		end

		if ( num > AV[highestAV] ) then
			highestAV = av;
		end
		haveConfirm = haveConfirm + num;
	end

	return highestAV, AV[highestAV], haveConfirm, unqueuedPeople, queuedPeople, people, allReady;
end

function Steamroller_DropDown_OnLoad()
	UIDropDownMenu_Initialize(SteamrollerFrameBGDropDown, Steamroller_CreateDropDownList);
	UIDropDownMenu_SetWidth(80, SteamrollerFrameBGDropDown);
	UIDropDownMenu_SetSelectedID(SteamrollerFrameBGDropDown, Steamroller_SelectedBG);
	UIDropDownMenu_SetText(STEAMROLLER_MAP_SHORT[Steamroller_SelectedBG], SteamrollerFrameBGDropDown)
	if not ( IsRaidLeader() or IsPartyLeader() ) then
		UIDropDownMenu_DisableDropDown(SteamrollerFrameBGDropDown);
	end
end

function Steamroller_DropDown_Update()
	UIDropDownMenu_SetSelectedID(SteamrollerFrameBGDropDown, Steamroller_SelectedBG);
	UIDropDownMenu_SetText(STEAMROLLER_MAP_SHORT[Steamroller_SelectedBG], SteamrollerFrameBGDropDown)
	if not ( IsRaidLeader() or IsPartyLeader() ) then
		UIDropDownMenu_DisableDropDown(SteamrollerFrameBGDropDown);
	else
		UIDropDownMenu_EnableDropDown(SteamrollerFrameBGDropDown);
	end
end

function Steamroller_CreateDropDownList()
	local info = UIDropDownMenu_CreateInfo();
	for i, val in pairs(STEAMROLLER_MAP_SHORT) do
		info.text = val;
		info.value = i
		info.checked = nil
		info.func = Steamroller_SelectBattlegroundClick;
		UIDropDownMenu_AddButton(info);
	end
end

function Steamroller_SelectBattlegroundClick()
	if ( IsRaidLeader() or IsPartyLeader() ) then
		if Steamroller_SelectedBG ~= this:GetID() then
			Steamroller_SelectedBG = tonumber(this:GetID())
			Steamroller_DropDown_Update()
			SendAddonMessage("Steamroller", "select,"..this:GetID(), "RAID")
		end
	end
end

function Steamroller_Leader()

	if ( IsRaidLeader() or IsPartyLeader() ) then

		local majorityAV, majorityPop, haveConfirm, unqueuedPeople, queuedPeople, people, allReady = Steamroller_Tally();

		if ( allReady ) then
			-- put this here so checking automate right after manualy queueing will work
			Steamroller_WaitUntilReady = false;
		end

		if ( Steamroller_Automating ) then

			if ( allReady ) then
				--SendAddonMessage("Steamroller", "queue", "RAID");
				Steamroller_MassQueue();
				return
			end

			-- prevent leave queue spam, and prevent unwanted behavior if automate is quickly checked after user hits leave queue
			if ( Steamroller_WaitUntilReady ) then
				return
			end

			-- any AVs at all?
			if ( majorityAV > 0 ) then
				-- check if threshold met, or everybody got the same AV
				if (	majorityPop >= Steamroller_Threshold or
					majorityPop >= people
				) then
					-- send join signal
					Steamroller_Automating = false;
					SteamrollerAutomateCheckButton:SetChecked(0);

					if ( Steamroller_Debug ) then
						DEFAULT_CHAT_FRAME:AddMessage("Sending signal to join AV "..majorityAV, 0, 1, 1);
					end
					SendAddonMessage("Steamroller", "join,"..majorityAV, "RAID");
				else

					-- is the threshold even possible to meet?
					if ( people > Steamroller_Threshold ) then

						-- if threshold impossible, send requeue signal
						-- do nothing otherwise
						if ( (majorityPop + queuedPeople + unqueuedPeople) < Steamroller_Threshold ) then
							if ( Steamroller_Debug ) then
								DEFAULT_CHAT_FRAME:AddMessage("Threshold now impossible;  Majority's AV has "..majorityPop.." people.  Queued People="..queuedPeople.."  Unqueued="..unqueuedPeople, 0, 1, 1);
								DEFAULT_CHAT_FRAME:AddMessage("Sending leave queue signal", 0, 1, 1);
							end
							SendAddonMessage("Steamroller", "leavequeue", "RAID");
							Steamroller_WaitUntilReady = true;
						end

					-- else the threshold is impossible to meet
					-- did everybody get an AV?  if not do nothing
					elseif ( haveConfirm >= people ) then
						-- everybody has an AV, not all match, and threshold not met
						if ( Steamroller_Debug ) then
							DEFAULT_CHAT_FRAME:AddMessage("Everybody has an AV, not all match, and threshold not met: "..haveConfirm, 0, 1, 1);
							DEFAULT_CHAT_FRAME:AddMessage("Sending leave queue signal", 0, 1, 1);
						end
						SendAddonMessage("Steamroller", "leavequeue", "RAID");
						Steamroller_WaitUntilReady = true;
					end
				end
			end -- if there are confirms

		end -- if automate checked
	end -- if group/raid leader
end

function Steamroller_AvStatus()
	local i, status, map, id;
	local avStatus, avId, avQid, currentBg, currentBgId = "none", 0, 1, 0, 0;

	for i=1, MAX_BATTLEFIELD_QUEUES do
		status, map, id = GetBattlefieldStatus(i);

		if ( map == STEAMROLLER_MAP[Steamroller_SelectedBG] ) then
			if ( status ~= "none" ) then
				avStatus = status;
				avId = id;
				avQid = i;
			end

		elseif ( status == "active" ) then
			for i, val in pairs(STEAMROLLER_MAP) do
				if ( map == val ) then
					currentBg = 3 + i;
					currentBgId = id;
				end
			end
		end
	end

	if ( not avStatus ) then
		avStatus = "none";
	end
	if ( not avId ) then
		avId = 0;
	end
	if ( not avQid ) then
		avQid = 1;
	end
	if ( not currentBg ) then
		currentBg = 0;
	end
	if ( not currentBgId ) then
		currentBgId = 0;
	end

	return avStatus, avId, avQid, currentBg, currentBgId;
end

function Steamroller_InsideBG()
	local instance, instanceType = IsInInstance();
	if ( instance and instanceType == "pvp" ) then
		return true;
	end
	return false;
end

function Steamroller_CheckBattlefieldFrame()
	if ( not BattlefieldFrame:IsVisible() ) then
--		if ( Steamroller_MyStatus.frame == 1 ) then
			-- player closed his instance window
--			Steamroller_ClosedTime = GetTime();
--		end
		Steamroller_MyStatus.frame = 0;
	else
		local mapName = GetBattlefieldInfo();
		if ( mapName == STEAMROLLER_MAP[Steamroller_SelectedBG] ) then
			Steamroller_MyStatus.frame = 1;
		else
			Steamroller_MyStatus.frame = 0;
		end
	end
end

function Steamroller_IsLeader(name)
	local i, unit;

	if ( GetNumRaidMembers() == 0 ) then
		-- this isn't a raid

		i = GetPartyLeaderIndex();

		if ( i > 0 ) then
			unit = "party"..i;
			if ( UnitName(unit) == name ) then
				if ( UnitIsPartyLeader(unit) ) then
					return true;
				end
			end
		else
			-- is player leader?
			if ( name == UnitName("player") ) then
				return true;
			end
		end

		return false;
	else
		-- this is a raid
		for i = 1, 40 do
			unit = "raid"..i;
			if ( UnitName(unit) == name ) then
				if ( UnitIsPartyLeader(unit) ) then
					return true;
				end
			end
		end
	end
end

function Steamroller_DetermineStatus()
	local avStatus, avId, avQid, currentBg, currentBgId = Steamroller_AvStatus();

	Steamroller_MyStatus.av = avId;

	if ( avStatus == "queued" ) then
		Steamroller_MyStatus.queued = 1;

	elseif ( avStatus == "confirm" ) then
		Steamroller_MyStatus.queued = 2;

	elseif ( avStatus == "active" ) then
		Steamroller_MyStatus.queued = 3;

	elseif ( currentBg > 0 ) then
		Steamroller_MyStatus.queued = currentBg;
		Steamroller_MyStatus.av = currentBgId;
	else
		Steamroller_MyStatus.queued = 0;
		Steamroller_MyStatus.av = 0;
	end

	Steamroller_CheckBattlefieldFrame();
end

function Steamroller_CheckStatus()
	-- if got raid member data, but never a status update
	if ( Steamroller_NeverUpdated == 1 ) then
		-- 2 == do not request status update when we open the status window to reduce redundancy
		Steamroller_NeverUpdated = 2;
	end
	Steamroller_DetermineStatus();
	Steamroller_SendStatus();
	Steamroller_LastCheck = GetTime() + 3;		-- prevent spam
end

function Steamroller_ParseAddonMsg(msg, sender)

	if ( msg == "statuscheck" ) then

		if ( Steamroller_Debug ) then
			DEFAULT_CHAT_FRAME:AddMessage("Status check requested from "..sender, 0, 1, 1);
		end

		Steamroller_CheckStatus()

	elseif ( msg == "queue" ) then
		if ( Steamroller_IsLeader(sender) ) then
			if ( Steamroller_Debug ) then
				DEFAULT_CHAT_FRAME:AddMessage("Queue signal seen", 0, 1, 1);
			end
			Steamroller_SetPending(0);
			Steamroller_Queue();
		end

	elseif ( msg == "join" ) then
		-- join the AV you got, regardless of number
		if ( Steamroller_IsLeader(sender) ) then
			if ( Steamroller_Debug ) then
				DEFAULT_CHAT_FRAME:AddMessage("Join signal seen (no specific)", 0, 1, 1);
			end
			local status, id, qid = Steamroller_AvStatus()
			if ( status == "confirm" ) then
				if ( not UnitIsAFK("player") ) then
					if ( Steamroller_Debug ) then
						DEFAULT_CHAT_FRAME:AddMessage("Entering", 0, 1, 1);
					end
					AcceptBattlefieldPort(qid, 1);
				end
			end
		end

	elseif ( msg == "leavequeue" ) then
		if ( Steamroller_IsLeader(sender) ) then
			if ( Steamroller_Debug ) then
				DEFAULT_CHAT_FRAME:AddMessage("Leave queue signal seen", 0, 1, 1);
			end
			Steamroller_SetPending(0);
			Steamroller_LeaveQueue();
		end

	elseif ( msg == "hide" ) then
		if ( Steamroller_IsLeader(sender) ) then
			if ( Steamroller_Debug ) then
				DEFAULT_CHAT_FRAME:AddMessage("Hide signal seen", 0, 1, 1);
			end
			Steamroller_HideTime = GetTime();
		end

	elseif ( msg == "notify" ) then
		if ( Steamroller_IsLeader(sender) ) then
			if ( Steamroller_Debug ) then
				DEFAULT_CHAT_FRAME:AddMessage("Notify signal seen", 0, 1, 1);
			end

			if (	Steamroller_MyStatus.frame == 0
				and (Steamroller_LastNotify < time() )
				and not IsInInstance()
			) then
				RaidNotice_AddMessage( RaidBossEmoteFrame, Steamroller_LocalString(STEAMROLLER_WAKE_UP), ChatTypeInfo["RAID_WARNING"] );
			        PlaySound("RaidWarning");
				Steamroller_LastNotify = time() + 10;		-- prevent spam
			end
		end

	elseif ( msg == "leaveall" ) then
		if ( Steamroller_IsLeader(sender) ) then
			if ( Steamroller_Debug ) then
				DEFAULT_CHAT_FRAME:AddMessage("Leave all battleground queues signal seen", 0, 1, 1);
			end
			local i, status, map, id;

			for i=1, MAX_BATTLEFIELD_QUEUES do
				status, map, id = GetBattlefieldStatus(i);
				if ( status == "confirm" or status == "queued" ) then
					if ( Steamroller_Debug ) then
						DEFAULT_CHAT_FRAME:AddMessage("Left "..map.." queue", 0, 1, 1);
					end
					AcceptBattlefieldPort(i, 0);
				end
			end
		end
	else

		local vars = {};
		local v, deserter;
		for v in string.gmatch(msg, "([^,]+)") do
			table.insert(vars, v);
		end

		if ( vars[1] == "mystatus" ) then
			if ( Steamroller_Debug ) then
				--DEFAULT_CHAT_FRAME:AddMessage(sender.." sent status ("..msg..")", 0, 1, 1);
			end
			if ( not Steamroller_Status[sender] ) then
				Steamroller_Status[sender] = {
					version = -1,
					frame = 0,
					queued = 0,
					av = 0,
					deserter = 0,
				};
			end

			if ( vars[2] ) then
				Steamroller_Status[sender].version = tonumber( vars[2] ); -- version
			end
			if ( vars[3] ) then
				Steamroller_Status[sender].frame = tonumber( vars[3] ); -- frame open/closed
			end

			if ( vars[4] ) then
				Steamroller_Status[sender].queued = tonumber( vars[4] ); -- confirm
			end

			if ( vars[5] ) then
				Steamroller_Status[sender].av = tonumber( vars[5] );  -- AV #
			end

			if ( vars[6] ) then
				deserter = tonumber( vars[6] );
				if ( deserter > 0 ) then
					Steamroller_Status[sender].deserter = deserter + GetTime();
				end
			end

			-- if the sender is the leader, use his selected battleground
			if ( vars[7] ) then		
				if ( Steamroller_IsLeader(sender) ) then
					local map = tonumber( vars[7] );
					if ( map ~= Steamroller_SelectedBG ) then
						Steamroller_SelectedBG = map;		-- switch the current selected BG to the one sent
						Steamroller_DropDown_Update()		-- update the dropdown box
						Steamroller_SetPending(0);			
						Steamroller_LeaveQueue();			-- if people are already queued for this BG, make them leave queue
						BattlefieldFrame:Hide();			-- close the battlefield window so the new status will be correct
						Steamroller_CheckStatus();
					end
				end
			end

			-- prevent many redraw calls at the same instant
			if ( Steamroller_OnUpdateTime < 9.5 and SteamrollerFrame:IsVisible() ) then
				Steamroller_Update();
				Steamroller_OnUpdateTime = 0;
			else
				Steamroller_OnUpdateTime = 9;
			end

			-- is player the leader with automate checked
			Steamroller_Leader();
			return

		elseif ( vars[1] == "select" ) then
			local map = tonumber(vars[2])
			if ( Steamroller_Debug ) then
				DEFAULT_CHAT_FRAME:AddMessage("Signal to select battleground "..map.." seen", 0, 1, 1);
			end
			if ( not Steamroller_IsLeader(sender) ) then
				return
			end
			Steamroller_SelectedBG = map;		-- switch the current selected BG to the one sent
			Steamroller_DropDown_Update()		-- update the dropdown box
			Steamroller_SetPending(0);			
			Steamroller_LeaveQueue();			-- if people are already queued for this BG, make them leave queue
			BattlefieldFrame:Hide();			-- close the battlefield window so the new status will be correct
			Steamroller_CheckStatus();
			return
			
		elseif ( vars[1] == "join" ) then
			if ( Steamroller_Debug ) then
				DEFAULT_CHAT_FRAME:AddMessage("Signal to join AV "..vars[2].." seen", 0, 1, 1);
			end
			if ( not Steamroller_IsLeader(sender) ) then
				return
			end

			Steamroller_SetPending(0);

			-- order was given to join a specific AV only
			local joinThis = tonumber( vars[2] );

			-- do I have an AV now, and is it the one I want?
			local status, id, qid = Steamroller_AvStatus();
--DEFAULT_CHAT_FRAME:AddMessage("join signal seen. my status is: "..status.."  id: "..id.."  ordered to join: "..joinThis.." quid: "..qid);
			if ( status == "confirm" ) then
				if ( id == joinThis ) then
--DEFAULT_CHAT_FRAME:AddMessage("accepting qid: "..qid);

					if ( not UnitIsAFK("player") ) then
						if ( Steamroller_Debug ) then
							DEFAULT_CHAT_FRAME:AddMessage("Entering AV "..id, 0, 1, 1);
						end
						AcceptBattlefieldPort(qid, 1);
					end
					return;
				end
			end
			if ( id ~= joinThis and id > 0 ) then
--DEFAULT_CHAT_FRAME:AddMessage("you have an AV, but not the right one");
				-- player has an AV, but not the right one
				-- leave queue, then queue up the specific AV
				Steamroller_LeaveQueue();

				if ( Steamroller_MyStatus.frame == 1 ) then
					Steamroller_Queue( joinThis );
				else
					Steamroller_SetPending( joinThis );
				end
				return
			end
			if ( status == "none" ) then
				-- not queued at all.  is battlefield frame open?
				-- if so, queue specific av
				Steamroller_CheckBattlefieldFrame();
				if ( Steamroller_MyStatus.frame == 1 ) then
--DEFAULT_CHAT_FRAME:AddMessage("status == none; frame open; queuing joinThis");
					-- frame is open, queue
					Steamroller_Queue( joinThis );
					return
				end
			end

			-- player queued for first available, is already queued for it,
			-- or frame not open
--DEFAULT_CHAT_FRAME:AddMessage("pending set to: "..joinThis);
			Steamroller_SetPending( joinThis );

		end

	end
end

function SteamrollerFrame_OnEvent(event, arg1, arg2, arg3, arg4)

	if ( event == "CHAT_MSG_ADDON" ) then
		if ( arg1 ~= "Steamroller" ) then
			return
		end
		Steamroller_ParseAddonMsg(arg2, arg4);

	elseif ( event == "PLAYER_ENTERING_WORLD" ) then

		if ( Steamroller_InsideBG() ) then

			if ( Steamroller_Debug ) then
				local avStatus, avId, avQid, currentBg, currentBgId = Steamroller_AvStatus();
				DEFAULT_CHAT_FRAME:AddMessage("AV Status: "..avStatus..";  AV ID: "..avId..";  AV QID: "..avQid, 0, 1, 1);
			end

			Steamroller_SetPending(0);
			Steamroller_DetermineStatus();
			Steamroller_SendStatus();
			Steamroller_Update();

			return;		-- don't want to GetMembers() inside a bg
		end

		Steamroller_GetMembers();
		Steamroller_SendStatus();

	elseif ( event == "PARTY_MEMBERS_CHANGED" or event == "RAID_ROSTER_UPDATE" ) then

		if ( Steamroller_InsideBG() ) then
			return
		end

--		if ( Steamroller_Debug ) then
--			DEFAULT_CHAT_FRAME:AddMessage("PARTY MEMBERS CHANGED, RAID ROSTER UPDATE", 0, 1, 1);
--		end

		Steamroller_GetMembers();

	elseif ( event == "BATTLEFIELDS_SHOW" ) then
		local mapName = GetBattlefieldInfo();

		if ( Steamroller_MapIsBattleground(mapName) ) then
			SteamrollerBFButton:Show();
			if ( mapName == STEAMROLLER_MAP[Steamroller_SelectedBG] ) then
				Steamroller_MyStatus.frame = 1;
				Steamroller_SendStatus();
				-- queue pending AV if player reopened window
				if ( Steamroller_Pending > 0 ) then
					Steamroller_Queue(Steamroller_Pending, true);
					Steamroller_SetPending(0);
				end
			end
		else
			SteamrollerBFButton:Hide();
		end

	elseif ( event == "UPDATE_BATTLEFIELD_STATUS" ) then

		local avStatus, avId, avQid, currentBg, currentBgId = Steamroller_AvStatus();

		if ( Steamroller_Debug ) then
			DEFAULT_CHAT_FRAME:AddMessage("UPDATE_BATTLEFIELD_STATUS event -- AV status: "..avStatus, 0, 1, 1);
		end

		Steamroller_MyStatus.av = avId;

		if ( avStatus == "confirm" ) then
--DEFAULT_CHAT_FRAME:AddMessage("got AV "..id);
			Steamroller_MyStatus.queued = 2;

			-- hide the popup window so the retards don't click in, but only if
			-- player is in 6+ member raid, not pending, queued time was less than 1 minute ago,
			-- player did not close the instance window within 3 seconds of being queued
--[[
			if (	GetNumRaidMembers() > 0 and
				Steamroller_Pending == 0 and
				( (Steamroller_QTime + 60) > GetTime() ) and
				( not Steamroller_PlayerQueuedHimself )
			) then

				local player, playerStatus, member;
				local doWeHide = true;
				local onlineMembers = 0;

				for _, member in pairs(Steamroller_Members) do

					playerStatus = Steamroller_Status[member.name];

					-- is this dude online?
					if ( member.online and playerStatus ) then

						if ( playerStatus.version ~= -1 ) then
							onlineMembers = onlineMembers + 1;

							-- is he not queued and does he have the addon?
							if ( playerStatus.queued == 0 ) then
								doWeHide = false;
							end
						end
					end
				end

				-- is every online raid member queued or confirm or inside?  are there more than 5 members w/ addon online?
				if ( doWeHide and onlineMembers > 5 ) then
					if ( Steamroller_Debug ) then
						DEFAULT_CHAT_FRAME:AddMessage("Hiding Popup", 0, 1, 1);
					end
					StaticPopup_Hide("CONFIRM_BATTLEFIELD_ENTRY", avQid);
				end
			end
]]
			-- hide confirm box if leader queued (sent hide signal) in last 30 seconds
			if ( (Steamroller_HideTime + 30) > GetTime() ) then
				if ( Steamroller_Debug ) then
					DEFAULT_CHAT_FRAME:AddMessage("Hiding Popup", 0, 1, 1);
				end
				StaticPopup_Hide("CONFIRM_BATTLEFIELD_ENTRY", avQid);
				Steamroller_HideTime = 0;
			end

			if ( Steamroller_Pending > 0 ) then
				if ( avId ~= Steamroller_Pending ) then
--DEFAULT_CHAT_FRAME:AddMessage("not the AV we want (pending = "..Steamroller_Pending..") requeueing");
					-- join specific AV only
					Steamroller_LeaveQueue();
					Steamroller_Queue(Steamroller_Pending);
				else
					-- we got in the AV we wanted
					Steamroller_SetPending(0);
					if ( not UnitIsAFK("player") ) then
						if ( Steamroller_Debug ) then
							DEFAULT_CHAT_FRAME:AddMessage("Entering AV "..avId, 0, 1, 1);
						end
						AcceptBattlefieldPort(avQid, 1);
					end
				end
			end

			Steamroller_SendStatus();

		elseif ( avStatus == "queued" ) then
			-- if newly queued
			if ( Steamroller_MyStatus.queued ~= 1 ) then
				Steamroller_SetPending(0);
				Steamroller_MyStatus.queued = 1;
				Steamroller_SendStatus();		-- only send status if changed to prevent redundancy
			end

--			Steamroller_QTime = GetTime();		-- get stampstamp

			-- if instance window didn't close within 3 seconds of being queued
--			if ( Steamroller_QTime - Steamroller_ClosedTime > 3 ) then
--				Steamroller_PlayerQueuedHimself = false;
--			else
--				Steamroller_PlayerQueuedHimself = true;
--			end

		elseif ( avStatus == "active" ) then
			if ( Steamroller_Debug ) then
				DEFAULT_CHAT_FRAME:AddMessage("ALTERAC VALLEY ACTIVE", 0, 1, 1);
			end
			if ( Steamroller_MyStatus.queued ~= 3 ) then
				Steamroller_MyStatus.queued = 3;
				Steamroller_SendStatus();
			end

		elseif ( avStatus == "none" ) then
			-- not queued for or inside an AV

			local queued, av;
			if ( currentBg > 0 ) then		-- inside a non-av bg?
				queued = currentBg;
				av = currentBgId;
			else
				queued = 0;
				av = 0;
			end

			if ( Steamroller_MyStatus.queued ~= queued ) then
				if ( Steamroller_Debug ) then
					DEFAULT_CHAT_FRAME:AddMessage("not inside AV; MyStatus.queued ("..Steamroller_MyStatus.queued..") ~= queued ("..queued..")", 0, 1, 1);
				end
				Steamroller_MyStatus.queued = queued;
				Steamroller_MyStatus.av = av;
				Steamroller_SendStatus();
			end
		end

	elseif ( event == "PARTY_LEADER_CHANGED" ) then
		Steamroller_SetWidgets();

	elseif ( event == "PARTY_INVITE_REQUEST" ) then
		Steamroller_NewGroup = true;
		if ( Steamroller_Debug ) then
			DEFAULT_CHAT_FRAME:AddMessage("PARTY_INVITE_REQUEST", 0, 1, 1);
		end
	end
end

function Steamroller_GetMembers()
	Steamroller_Members = {};
	local name, online;
	local numRaidMembers = GetNumRaidMembers();
	if ( numRaidMembers == 0 ) then

		-- Party members
		for i=1, MAX_PARTY_MEMBERS do
			if ( GetPartyMember(i) ) then
				name = UnitName("party"..i);
				online = UnitIsConnected("party"..i);
				Steamroller_Members[i] = { name = name, online = online };
				if ( not Steamroller_Status[name] ) then
					Steamroller_Status[name] = {
						version = -1,			-- unknown / not installed
						frame = 0,
						queued = 0,
						av = 0,
						deserter = 0,
					};
				end
			end
		end

		-- player
		name = UnitName("player");
		online = UnitIsConnected("player");
		Steamroller_Members[5] = { name = name, online = online };
		if ( not Steamroller_Status[name] ) then
			Steamroller_Status[name] = {
				version = -1,			-- unknown / not installed
				frame = 0,
				queued = 0,
				av = 0,
				deserter = 0,
			};
		end

	else

		-- Raid
		for i=1, MAX_RAID_MEMBERS do
			name, _, _, _, _, _, _, online = GetRaidRosterInfo(i);
			if ( name ) then
				Steamroller_Members[i] = { name = name, online = online };
				if ( not Steamroller_Status[name] ) then
					Steamroller_Status[name] = {
						version = -1,			-- unknown / not installed
						frame = 0,
						queued = 0,
						av = 0,
						deserter = 0,
					};
				end
			end
		end

	end

	-- raid member data loaded
	Steamroller_NeverUpdated = 1;

	-- only send status if new to the group
	-- or player is newly deserter (check put here because PLAYER_ENTERING_WORLD seems to fire before client gets the icon
	-- or we still have not seen a status update from myself
	if (	Steamroller_NewGroup or
		(Steamroller_MyStatus.deserter == 0 and Steamroller_CheckDeserter() > 0) or
		Steamroller_Status[UnitName("player")].version == -1
	) then
		Steamroller_SendStatus();
	end
	Steamroller_NewGroup = false;

	Steamroller_Update();
end

function Steamroller_CheckDeserter()
	local i, name, icon, texture, hasDeserter;

	for i=1, MAX_PARTY_DEBUFFS do
		name, _, icon = UnitDebuff("player", i);
		if ( name == STEAMROLLER_DESERTER ) then
			hasDeserter = true;
			break;
		end
	end

	if ( not hasDeserter ) then
		return 0;
	end

	for i = 0, 15 do
		texture = GetPlayerBuffTexture(i);
		if ( texture == icon ) then
			return math.ceil( GetPlayerBuffTimeLeft(i) );
		end
	end

	return 0;
end

function Steamroller_Update()
	local member, i, j, fontStr, name, status, deserterTime;

	i = 0;
	for _, member in pairs( Steamroller_Members ) do
		i = i + 1;
		fontStr = getglobal("SteamrollerMember"..i);

		name = member.name;
		status = Steamroller_Status[name];

		fontStr = getglobal("SteamrollerMember"..i.."NameText")
		fontStr:SetText(name);
		fontStr:SetTextColor(1, .82, 0);

		if ( not member.online ) then
			getglobal("SteamrollerMember"..i.."FrameText"):SetText("Offline");
			getglobal("SteamrollerMember"..i.."NameText"):SetTextColor(.5, .5, .5);
			getglobal("SteamrollerMember"..i.."FrameText"):SetTextColor(.5, .5, .5);

			getglobal("SteamrollerMember"..i.."QueueText"):SetText("");
			getglobal("SteamrollerMember"..i.."AVText"):SetText("");
			getglobal("SteamrollerMember"..i.."VersionText"):SetText("");

		elseif ( status.version == -1 ) then
			fontStr = getglobal("SteamrollerMember"..i.."VersionText");
			fontStr:SetText("");
			fontStr:SetTextColor(.5, .5, .5);

			fontStr = getglobal("SteamrollerMember"..i.."FrameText");
			fontStr:SetText(STEAMROLLER_NOTINSTALLED);
			fontStr:SetTextColor(.5, .5, .5);

			getglobal("SteamrollerMember"..i.."QueueText"):SetText("");
			getglobal("SteamrollerMember"..i.."AVText"):SetText("");

		else
			fontStr = getglobal("SteamrollerMember"..i.."VersionText");
			fontStr:SetText(status.version);
			if ( status.version < Steamroller_Version ) then
				fontStr:SetTextColor(.8, .4, .4);
			else
				fontStr:SetTextColor(.8, .8, .8);
			end

			fontStr = getglobal("SteamrollerMember"..i.."FrameText");
			if ( status.frame == 1 ) then
				fontStr:SetText(STEAMROLLER_OPEN);
				fontStr:SetTextColor(.1, 1, .1);
			else
				fontStr:SetText(STEAMROLLER_CLOSED);
				fontStr:SetTextColor(1, .1, .1);
			end

			fontStr = getglobal("SteamrollerMember"..i.."QueueText");
			if ( status.queued == 1 ) then
				fontStr:SetText(STEAMROLLER_QUEUED);
				fontStr:SetTextColor(.1, 1, 1);
			elseif ( status.queued == 2 ) then
				fontStr:SetText(STEAMROLLER_CONFIRM);
				fontStr:SetTextColor(1, 1, .1);
			elseif ( status.queued == 3 ) then
				fontStr:SetText(STEAMROLLER_INSIDE);
				fontStr:SetTextColor(1, 1, 1);
			elseif ( status.queued > 3 ) then
				local map = status.queued - 3
				fontStr:SetText(STEAMROLLER_MAP_SHORT[map]);
				fontStr:SetTextColor(.5, .5, .5);
			else
				fontStr:SetText("");
			end

			fontStr = getglobal("SteamrollerMember"..i.."AVText");
			if ( status.av > 0 ) then
				fontStr:SetText(status.av);
				if ( status.queued >= 4 ) then
					fontStr:SetTextColor(.5, .5, .5);
				else
					fontStr:SetTextColor(1, 1, 0);
				end
			else
				if ( status.queued == 1 ) then
					fontStr:SetText(STEAMROLLER_FIRSTAVAIL);
					fontStr:SetTextColor(1, 1, 1);
				else
					fontStr:SetText("");
				end
			end

			fontStr = getglobal("SteamrollerMember"..i.."QueueText");
			if ( status.deserter > 0 ) then

				if ( status.deserter > GetTime() ) then
					deserterTime = status.deserter - GetTime();
					fontStr:SetText(STEAMROLLER_DESERTER.." "..string.format(SecondsToTimeAbbrev(deserterTime)));
					fontStr:SetTextColor(1, .1, .1);
					fontStr = getglobal("SteamrollerMember"..i.."AVText"):SetText("");
				else
					status.deserter = 0;
					if ( name == UnitName("player") ) then
						Steamroller_MyStatus.deserter = Steamroller_CheckDeserter();
					end
				end
			end

		end -- if online
	end -- for member in

	-- blank out the rest
	for j = (i + 1), 40 do
		getglobal("SteamrollerMember"..j.."NameText"):SetText("");
		getglobal("SteamrollerMember"..j.."FrameText"):SetText("");
		getglobal("SteamrollerMember"..j.."QueueText"):SetText("");
		getglobal("SteamrollerMember"..j.."AVText"):SetText("");
		getglobal("SteamrollerMember"..j.."VersionText"):SetText("");
	end

	-- Majority text
	local majorityAV, majorityPop, _, _, queuedPeople, people = Steamroller_Tally();
	if ( majorityAV == 0 ) then
		if ( queuedPeople == 0 ) then
			SteamrollerMajorityText:SetText("");
		else
			SteamrollerMajorityText:SetText(""..STEAMROLLER_QUEUED..": "..queuedPeople);
			SteamrollerMajorityText:SetTextColor(.1, 1, 1);
		end
	else
		SteamrollerMajorityText:SetText(""..STEAMROLLER_CONFIRM.." "..majorityAV..": "..majorityPop);
		SteamrollerMajorityText:SetTextColor(1, 1, .1);
	end

end

function SteamrollerFrameStatusButton_OnClick()
	-- prevent spam clicking
	if ( Steamroller_LastCheck < GetTime() ) then
		SendAddonMessage("Steamroller", "statuscheck", "RAID");
		Steamroller_LastCheck = GetTime() + 5;
	end
end

function SteamrollerFrameLeaveButton_OnClick()
	if ( IsRaidLeader() or IsPartyLeader() ) then
		Steamroller_WaitUntilReady = true;				-- so automate doesn't try to get people to join games until ready
		SendAddonMessage("Steamroller", "leavequeue", "RAID");
	else
		Steamroller_SetPending(0);
		Steamroller_LeaveQueue();
	end
end

function SteamrollerCmdLine(param)
	if ( param == "debug" ) then
		if ( Steamroller_Debug ) then
			Steamroller_Debug = false;
			DEFAULT_CHAT_FRAME:AddMessage("Debug mode off");
		else
			Steamroller_Debug = true;
			DEFAULT_CHAT_FRAME:AddMessage("Debug mode on");
		end

	elseif ( param == "reset" ) then
		SteamrollerFrame:ClearAllPoints();
		SteamrollerFrame:SetPoint("RIGHT", UIParent, "RIGHT", -50, 25);

	else
		SteamrollerFrame:Show();
	end
end

function SteamrollerFrameNotifyButton_OnClick()
	if ( IsRaidLeader() or IsPartyLeader() ) then
		SendAddonMessage("Steamroller", "notify", "RAID");
	end
end
